﻿using System;
using System.Collections.Generic;

namespace Adaptation.Helpers
{

    public partial class ConfigData
    {
        public enum Level
        {
            IsXToOpenInsightMetrologyViewer, //MetrologyWS.SendData(file, string.Concat("http://", serverName, "/api/inbound/MercuryProbe"), headerAttachments);
            IsXToIQSSi, //NA <d7p1:FileScanningIntervalInSeconds>-361</d7p1:FileScanningIntervalInSeconds>
            IsXToOpenInsight, //NA <d7p1:FileScanningIntervalInSeconds>-363</d7p1:FileScanningIntervalInSeconds>
            IsXToOpenInsightMetrologyViewerAttachments, //Site-One
            IsXToAPC,
            IsXToSPaCe,
            IsXToArchive,
            IsArchive,
            IsDummy,
            IsNaEDA
        }

        public static List<Tuple<int, Enum, string>> LevelTuples
        {
            get
            {
                return new List<Tuple<int, Enum, string>>
                {
                    new Tuple<int, Enum, string>(0, Level.IsNaEDA, @"\EC_EDA\Staging\Traces\~\Source"),
                    new Tuple<int, Enum, string>(15, Level.IsXToOpenInsightMetrologyViewer, @"\EC_EAFLog\TracesMES\~\Source"),
                    new Tuple<int, Enum, string>(-36, Level.IsXToIQSSi, @"\EC_SPC_Si\Traces\~\PollPath"),
                    new Tuple<int, Enum, string>(-36, Level.IsXToOpenInsight, @"\\messa01ec.ec.local\APPS\Metrology\~\Source"),
                    new Tuple<int, Enum, string>(36, Level.IsXToOpenInsightMetrologyViewerAttachments, @"\EC_Characterization_Si\In Process\~\Source"),
                    new Tuple<int, Enum, string>(360, Level.IsXToAPC, @"\EC_APC\Staging\Traces\~\PollPath"),
                    new Tuple<int, Enum, string>(-36, Level.IsXToSPaCe, @"\EC_SPC_Si\Traces\~\Source"),
                    new Tuple<int, Enum, string>(180, Level.IsXToArchive, @"\EC_EAFLog\TracesArchive\~\Source"),
                    new Tuple<int, Enum, string>(36, Level.IsArchive, @"\EC_Characterization_Si\Processed")
                    //new Tuple<int, Enum, string>("IsDummy"
                };
            }
        }

    }

}